# Generated by Django 3.2.19 on 2023-07-01 15:25
from django.contrib.contenttypes.models import ContentType
from django.db import migrations, models
import django.db.models.deletion
from django.db.models import F

from product.models import Product


def move_to_generic_fk(apps, schema_editor):
    db_alias = schema_editor.connection.alias
    product_content_type = ContentType.objects.get_for_model(Product)
    apps.get_model('contribution_plan', 'contributionplan').objects.using(db_alias).update(benefit_plan_id=F('benefit_plan_temp'), benefit_plan_type=product_content_type)
    apps.get_model('contribution_plan', 'historicalcontributionplan').objects.using(db_alias).update(benefit_plan_id=F('benefit_plan_temp'), benefit_plan_type=product_content_type)
    apps.get_model('contribution_plan', 'paymentplan').objects.using(db_alias).update(benefit_plan_id=F('benefit_plan_temp'), benefit_plan_type=product_content_type)
    apps.get_model('contribution_plan', 'historicalpaymentplan').objects.using(db_alias).update(benefit_plan_id=F('benefit_plan_temp'), benefit_plan_type=product_content_type)

class Migration(migrations.Migration):
    replaces=[('contribution_plan','0003_benefit_plan_generic_fk')]
    dependencies = [
        ('product', '0008_auto_20230510_1347'),
        ('contribution_plan', '0002_auto_20230126_0903'),
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.AlterField(
            model_name='contributionplan',
            name='benefit_plan',
            field=models.ForeignKey(db_column='BenefitPlanID_temp', on_delete=django.db.models.deletion.DO_NOTHING,
                                    to='product.product'),
        ),
        migrations.AlterField(
            model_name='historicalcontributionplan',
            name='benefit_plan',
            field=models.ForeignKey(blank=True, db_column='BenefitPlanID_temp', db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING, related_name='+',
                                    to='product.product'),
        ),
        migrations.AlterField(
            model_name='historicalpaymentplan',
            name='benefit_plan',
            field=models.ForeignKey(blank=True, db_column='BenefitPlanID_temp', db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING, related_name='+',
                                    to='product.product'),
        ),
        migrations.AlterField(
            model_name='paymentplan',
            name='benefit_plan',
            field=models.ForeignKey(db_column='BenefitPlanID_temp', on_delete=django.db.models.deletion.DO_NOTHING,
                                    to='product.product'),
        ),
        migrations.RenameField(
            model_name='contributionplan',
            old_name='benefit_plan',
            new_name='benefit_plan_temp',
        ),
        migrations.RenameField(
            model_name='historicalcontributionplan',
            old_name='benefit_plan',
            new_name='benefit_plan_temp',
        ),
        migrations.RenameField(
            model_name='historicalpaymentplan',
            old_name='benefit_plan',
            new_name='benefit_plan_temp',
        ),
        migrations.RenameField(
            model_name='paymentplan',
            old_name='benefit_plan',
            new_name='benefit_plan_temp',
        ),
        migrations.AddField(
            model_name='contributionplan',
            name='benefit_plan_id',
            field=models.CharField(blank=True, db_column='BenefitPlanID', max_length=255, null=True),
        ),
        migrations.AddField(
            model_name='contributionplan',
            name='benefit_plan_type',
            field=models.ForeignKey(db_column='BenefitPlanType', null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING, to='contenttypes.contenttype'),
        ),
        migrations.AddField(
            model_name='historicalcontributionplan',
            name='benefit_plan_id',
            field=models.CharField(blank=True, db_column='BenefitPlanID', max_length=255, null=True),
        ),
        migrations.AddField(
            model_name='historicalcontributionplan',
            name='benefit_plan_type',
            field=models.ForeignKey(blank=True, db_column='BenefitPlanType', db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING, related_name='+',
                                    to='contenttypes.contenttype'),
        ),
        migrations.AddField(
            model_name='historicalpaymentplan',
            name='benefit_plan_id',
            field=models.CharField(blank=True, db_column='BenefitPlanID', max_length=255, null=True),
        ),
        migrations.AddField(
            model_name='historicalpaymentplan',
            name='benefit_plan_type',
            field=models.ForeignKey(blank=True, db_column='BenefitPlanType', db_constraint=False, null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING, related_name='+',
                                    to='contenttypes.contenttype'),
        ),
        migrations.AddField(
            model_name='paymentplan',
            name='benefit_plan_id',
            field=models.CharField(blank=True, db_column='BenefitPlanID', max_length=255, null=True),
        ),
        migrations.AddField(
            model_name='paymentplan',
            name='benefit_plan_type',
            field=models.ForeignKey(db_column='BenefitPlanType', null=True,
                                    on_delete=django.db.models.deletion.DO_NOTHING, to='contenttypes.contenttype'),
        ),
        migrations.RunPython(move_to_generic_fk),
        migrations.RemoveField(
            model_name='historicalcontributionplan',
            name='benefit_plan_temp',
        ),
        migrations.RemoveField(
            model_name='historicalpaymentplan',
            name='benefit_plan_temp',
        ),
        migrations.RemoveField(
            model_name='contributionplan',
            name='benefit_plan_temp',
        ),
        migrations.RemoveField(
            model_name='paymentplan',
            name='benefit_plan_temp',
        ),
    ]
